//pl0语法分析的验证程序
// 要点：
//     1 本例有9个函数：函数block、constdeclaration、vardeclaration、statement、condition、expression、term、
//        factor分别用于程序体、常量声明、变量声明、语句、条件表达式、表达式、项和因子的语法分析并生成对应的中间代码。
// 关键字：变量不变式、宏定义、带命名行为的函数协议、归纳谓词
#include <stdio.h>
#include "specification.h"

//@ ghost _Bool nested_level_too_shallow;

void constdeclaration(){
    char idTmp[al+1];                    // 为验证而增加的声明。    这三处增加的代码为了一个目的。用常量说明const val = 10;来解释。
    long numTmp;                    // 为验证而增加的声明。    同上，要等到可以把getsym函数写成多命名行为的协议时，才能把这些增加的代码删去。

    if(sym==ident){                    //                这时"val"存在id数组中。
        strcpy(idTmp, id);                // 为验证而增加的代码。
        getsym();                    //                getsym在读到标识符或保留字时会修改id数组，虽然在读到"="时不修改。getsym函数现在的代码写不出两个协议来区分
        if(sym==eql||sym==becomes){            //                修改和不修改全局数组id，因而函数协议体现出的是：只要调用getsym，就可能修改id。若想让getsym能适应写出两个协议，
            if(sym==becomes){                //                代码需要修改的地方很多，因此不得不用在此增加代码的方式。
                error(1);
                /*@ ghost stop_here = true; */
                exit(2);                // 增加该语句是为了避免验证错误恢复功能。 
            }
            getsym();
            if(sym==number){
                strcpy(id, idTmp);            // 为验证而增加的代码。    先前的strcpy(idTmp, id)把id保存起来，这里的strcpy(id, idTmp)恢复id的内容，使得下面的调用语句能顺利验证。
                enter(constant);            //                实际上不加这些代码，id的内容还是"val"，因为读取其后的"="和“10”并不修改id的内容。
                numTmp = num;                // 为验证而增加的代码。
                getsym();
                num = numTmp;                // 为验证而增加的代码。
                strcpy(id, idTmp);            // 为验证而增加的代码。    先前的strcpy(idTmp, id)把id保存起来，这里的strcpy(id, idTmp)恢复id的内容，使得函数出口能顺利验证。
            }else{
                error(2);
                /*@ ghost stop_here = true; */
                exit(2);                // 增加该语句是为了避免验证错误恢复功能。
            }
        }else{
            error(3);
            /*@ ghost stop_here = true; */
            exit(2);                    // 增加该语句是为了避免验证错误恢复功能。        
        }
    }else{
        error(4);
        /*@ ghost stop_here = true; */
        exit(2);                    // 增加该语句是为了避免验证错误恢复功能。
    }
}


void vardeclaration(){
    char idTmp[al+1];                    // 为验证而增加的代码。同constdeclaration。

    if(sym==ident){
        enter(variable);
        strcpy(idTmp, id);                // 为验证而增加的代码。
           getsym();
        strcpy(id, idTmp);                // 为验证而增加的代码。
    }else{
        error(4);
        /*@ ghost stop_here = true; */
        exit(2);                    // 增加该语句是为了避免验证错误恢复功能。
    }
}


void listcode(const long cx0){    // list code generated for this block
    long i;
    //@ loop invariant cx0 < cx && 0 <= cx0 <= i <= cx;
    for(i=cx0; i<=cx-1; i++){
        printf("%10ld%5s%3ld%5ld\n", i, mnemonic[code[i].f], code[i].l, code[i].a);
    }
}

void factor(const long fsys){
    long i;
    
    test(facbegsys,fsys,24);
    if(sym==ident){    //在Pascal版本中，这里是while语句，以便源程序中出现因子连续的语法错误时，能及时删除。
        i=position(id); //这给验证语法分析器正确与否带来困难。因而改成条件语句，并增加了函数末尾的幽灵语句。
    if(i==0){    //所做的修改不影响对正确程序的语法分析。
        error(11);
        /*@ ghost stop_here = true; */
        exit(2);                    // 增加该语句是为了避免验证错误恢复功能。
    }else{
        switch(table[i].kind){
            case constant:
                gen(lit,0,table[i].val);
                break;
            case variable:
                gen(lod,lev-table[i].level,table[i].addr);
                break;
            case proc:
                error(21);
                /*@ ghost stop_here = true; */
                exit(2);                    // 增加该语句是为了避免验证错误恢复功能。
        }
    }
    getsym();
    }else if(sym==number){
        if(num>amax){
            error(31); 
            num=0;
        }
        gen(lit,0,num);
        getsym();
    }else if(sym==lparen){
        getsym();
        expression(rparen|fsys);
    if(sym==rparen){
        getsym();
    }else{
        error(22);
        //@ ghost stop_here = true;
        exit(2);                    // 增加该语句是为了避免验证错误恢复功能。
    }
    }else{
        error(25);                        //因子不能以此符号开始。
        /*@ ghost stop_here = true; */
        exit(2);                    // 增加该语句是为了避免验证错误恢复功能。
    }
    test(fsys,0,23);
}

void term(const long fsys){
    unsigned long mulop;
    //@ ghost long index1, index2;
    factor(fsys|times|slash);
    //@ ghost index1 = symStreamIndex-1; index2 = cx-1;

    /*@ loop invariant
            currentCodeLineAndExtra && currentSymbol && symStream[symStreamIndex] == sym && \old(symStreamIndex) <= index1 <= symStreamIndex-1
            && Factor(symStream, \old(symStreamIndex), index1) && FactorSeq(symStream, index1+1, symStreamIndex-1)
            && FactorCode(code, \old(cx), index2) && FactorSeqCode(code, index2+1, cx-1) && \old(cx) <= index2 <= cx-1
            && symStreamIndex > \old(symStreamIndex) >= 0 && cx > \old(cx)
            ;
    */
    while(sym==times||sym==slash){
        mulop=sym;
        getsym();
        factor(fsys|times|slash);
        if(mulop==times){
            gen(opr,0,4);
        }else{
            gen(opr,0,5);
        }
    }
}

void expression(const long fsys){
    unsigned long addop;
    //@ ghost long index1, index2;
    if(sym==plus||sym==minus){
        addop=sym;
        getsym();
        term(fsys|plus|minus);
        if(addop==minus){
            gen(opr,0,1);
        }
    }else{
        term(fsys|plus|minus);
    }
    //@ ghost index1 = symStreamIndex-1; index2 = cx-1;
    //循环不变式分成两种情况
        //情况1：表达式由正号、项和项序列构成，或者由负号、项和项序列构成，或者由项和项序列构成；
        //情况2：表达式由项和项序列构成。    
    /*@ loop invariant
            currentCodeLineAndExtra && currentSymbol && symStream[symStreamIndex] == sym && symStreamIndex > \old(symStreamIndex) >= 0 && cx > \old(cx) 
            &&
            (
            (symStream[\old(symStreamIndex)]==plus || symStream[\old(symStreamIndex)]==minus) && Term(symStream,\old(symStreamIndex)+1,index1) 
            && TermSeq(symStream,index1+1,symStreamIndex-1)&& (symStream[\old(symStreamIndex)]==plus ? TermCode(code,\old(cx),index2) 
            && TermSeqCode(code,index2+1,cx-1) : TermCode(code,\old(cx),index2-1) && code[index2].f==opr && code[index2].l==0 && code[index2].a==1 && TermSeqCode(code,index2+1,cx-1))
            || 
            (symStream[\old(symStreamIndex)] != plus && symStream[\old(symStreamIndex)] != minus && Term(symStream, \old(symStreamIndex), index1)
            && TermSeq(symStream, index1+1, symStreamIndex-1) && TermCode(code, \old(cx), index2) && TermSeqCode(code, index2+1, cx-1))
            )
            ;
    */
    while(sym==plus||sym==minus){
        addop=sym;
        getsym();
        term(fsys|plus|minus);
        if(addop==plus){
            gen(opr,0,2);
        }else{
            gen(opr,0,3);
        }
    }
}

void condition(const long fsys){
    long relop;
/*@predicate currentRelop1(long sys)=
    sys == beginsym || sys == endsym || sys == ifsym || sys == thensym ||
    sys == whilesym || sys == dosym || sys == callsym || sys == constsym ||
    sys == varsym || sys == procsym || sys == oddsym || 
    sys == ident || sys == number ||
    sys == neq || sys == lss || sys == leq || sys == gtr || sys == geq || sys==becomes ||
    sys == plus || sys == minus || sys == times || sys == slash || sys == lparen ||
    sys == rparen || sys == comma || sys == semicolon || sys == period || sys == eql ||
    sys == nul;
*/

    if(sym==oddsym){
        getsym();
        expression(fsys);
        gen(opr,0,6);
    }else{
        expression(fsys|eql|neq|lss|gtr|leq|geq);
        if(!(sym & (eql|neq|lss|gtr|leq|geq))){
            error(20);
            /*@ ghost stop_here = true; */
            exit(2);                // 增加该语句是为了避免验证错误恢复功能。
    }else{
        relop=sym; 
        getsym();
        expression(fsys);
        switch(relop){
        case eql:
            gen(opr,0,8);
            break;
        case neq:
            gen(opr,0,9);
            break;
        case lss:
            gen(opr,0,10);
            break;
        case geq:
            gen(opr,0,11);
            break;
        case gtr:
            gen(opr,0,12);
            break;
        case leq:
            gen(opr,0,13);
            break;
        }
    }
    }
    /*@lemma p1: 
    relop!=eql && relop!=neq && relop!=lss && relop!=geq && relop!=gtr && relop!=leq && currentRelop1(relop)
    ==> (relop & (eql|neq|lss|gtr|leq|geq))==0;
    */
}


void statement(const long fsys){
    long i,cx1,cx2;
    if(sym==ident){
    i=position(id);
    if(i==0){
        error(11);
        /*@ ghost stop_here = true; */
        exit(2);                // 增加该语句是为了避免验证错误恢复功能。
    }else if(table[i].kind!=variable){    // assignment to non-variable
        error(12); i=0;
        /*@ ghost stop_here = true; */
        exit(2);                // 增加该语句是为了避免验证错误恢复功能。
    }
    getsym();
    if(sym==becomes){
        getsym();
    }else{
        error(13);
        /*@ ghost stop_here = true; */
        exit(2);                // 增加该语句是为了避免验证错误恢复功能。
    }
    expression(fsys);
    if(i!=0){
        gen(sto,lev-table[i].level,table[i].addr);
    }
    }else if(sym==callsym){
    getsym();
    if(sym!=ident){
        error(14);
        /*@ ghost stop_here = true; */
        exit(2);                // 增加该语句是为了避免验证错误恢复功能。
    }else{
        i=position(id);
        if(i==0){
        error(11);
        /*@ ghost stop_here = true; */
        exit(2);            // 增加该语句是为了避免验证错误恢复功能。
        }else if(table[i].kind==proc){
        gen(cal,lev-table[i].level,table[i].addr);
        }else{
        error(15);
        /*@ ghost stop_here = true; */
        exit(2);            // 增加该语句是为了避免验证错误恢复功能。
        }
        getsym();
    }
    }else if(sym==ifsym){
    getsym(); condition(fsys|thensym|dosym);
    if(sym==thensym){
        getsym();
    }else{
        error(16);
        /*@ ghost stop_here = true; */
        exit(2);                // 增加该语句是为了避免验证错误恢复功能。
    }
    cx1=cx;    gen(jpc,0,0);                            // cx1记住当前要生成的jpc指令在code数组中的地址。
    statement(fsys);
    code[cx1].a=cx;    
    }else if(sym==beginsym){
    getsym(); statement(fsys|semicolon|endsym);
    /*@ loop invariant
            currentCodeLineAndExtra && currentSymbol && symStream[\old(symStreamIndex)] == beginsym 
            && StmtSeq(symStream, \old(symStreamIndex)+1, symStreamIndex-1) && StmtSeqCode(code,\old(cx), cx-1)
            && symStream[symStreamIndex] == sym && symStreamIndex > \old(symStreamIndex) >= 0 && cx >= \old(cx);
    */
    while(sym==semicolon||(sym&statbegsys)){
        if(sym==semicolon){
        getsym();
        }else{
        error(10);
        /*@ ghost stop_here = true; */
        exit(2);            // 增加该语句是为了避免验证错误恢复功能。
        }
        statement(fsys|semicolon|endsym);
    }
    if(sym==endsym){
        getsym();
    }else{
        error(17);
        /*@ ghost stop_here = true; */
        exit(2);                // 增加该语句是为了避免验证错误恢复功能。
    }
    }else if(sym==whilesym){
    cx1=cx; getsym();
    condition(fsys|dosym);
    cx2=cx;    gen(jpc,0,0);
    if(sym==dosym){
        getsym();
    }else{
        error(18);
        /*@ ghost stop_here = true; */
        exit(2);                // 增加该语句是为了避免验证错误恢复功能。
    }
    statement(fsys); gen(jmp,0,cx1);
    code[cx2].a=cx;
    }
    test(fsys,0,19);
}


void block(long fsys){
    long tx0;    // initial table index
    long cx0;     // initial code index
    long tx1;    // save current table index before processing nested procedures
    long dx1;    // save data allocation index
    //@ ghost long index11, index21, index31, index03;
    dx = 3; tx0 = tx; table[tx].addr = cx;
    //@ ghost index03 = cx;
    gen(jmp,0,0);
    //@ ghost index11 = symStreamIndex;
    if(sym==constsym){
        getsym();
        constdeclaration();
        /*@ loop invariant 
           currentCodeLineAndExtra && currentSymbol && symStream[symStreamIndex] == sym && tx0 == \old(tx) < tx 
           && dx == 3 && cx == index03+1 && index03 == \old(cx) && table[tx0].addr == index03 && 0 <= tx0 <= txmax
           && 0 <= \old(cx) <= cxmax+1 && index11 == \old(symStreamIndex) && symStream[index11] == constsym
           && ConstDefSeq(symStream, index11+1, symStreamIndex-1) && symStreamIndex >= \old(symStreamIndex)+4
           && code[index03].f == jmp && code[index03].l == 0 && code[index03].a == 0 &&    symStreamIndex > \old(symStreamIndex) >= 0
           ;
        */
        while(sym==comma){
            getsym();
            constdeclaration();
        }
        if(sym==semicolon){
            getsym();
        }else{
            error(5);
            /*@ ghost stop_here = true; */
            exit(2);                // 增加该语句是为了避免验证错误恢复功能。
        }
    }
    //@ ghost index21 = symStreamIndex;
    if(sym==varsym){
        getsym();
        vardeclaration();
        //循环不变式分成两种情况
        //情况1：循环入口初始状态
        //情况2：循环迭代及终止状态
        /*@ loop invariant
            currentCodeLineAndExtra && currentSymbol && symStream[symStreamIndex] == sym && tx0 == \old(tx) 
            && cx == index03+1 && index03 == \old(cx) && table[tx0].addr == index03 && 0 <= tx0 <= txmax && 0 <= \old(cx) <= cxmax+1
            && index11 == \old(symStreamIndex) && ConstDecl(symStream, index11, index21-1) && symStream[index21] == varsym 
            && VarDecSeq(symStream, index21+1, symStreamIndex-1) && code[index03].f == jmp && code[index03].l == 0 && code[index03].a == 0
            && index11 <= index21 <= symStreamIndex && tx > \old(tx) && symStreamIndex > \old(symStreamIndex) >= 0
            ||
            currentCodeLineAndExtra && currentSymbol && symStream[symStreamIndex] == sym && tx0 == \old(tx)
            && cx == index03+1 && index03 == \old(cx) && table[tx0].addr == index03 && 0 <= tx0 <= txmax && 0 <= \old(cx) <= cxmax+1
            && index11 == \old(symStreamIndex) && ConstDecl(symStream, index11, index21-1) && index11 <= index21 <= symStreamIndex 
            && tx > \old(tx) && symStream[index21] == varsym && VarDecSeq(symStream, index21+1, symStreamIndex-3) 
            && symStream[symStreamIndex-2] == comma && VarDecSeq(symStream, symStreamIndex-1, symStreamIndex-1)
            && code[index03].f == jmp && code[index03].l == 0 && code[index03].a == 0 && symStreamIndex > \old(symStreamIndex) >= 0
            ;
        */
        while(sym==comma){
            getsym();
            vardeclaration();
        }
        if(sym==semicolon) {
            getsym();
        }else{
            error(5);
            /*@ ghost stop_here = true; */
            exit(2);                // 增加该语句是为了避免验证错误恢复功能。
        }
    }
    //@ ghost index31 = symStreamIndex;

    /*@ lemma special_for_ProcDecl:        // 把归纳定义ProcDecl的第一和第三个变元分别确定为symStream和symStreamIndex-1，以降低Z3发现该归纳定义可用的难度。
        \forall integer x. symStreamIndex-1 >= x +3 && symStream[x] == procsym && symStream[x+1] == ident && symStream[x+2] == semicolon && Block(symStream, x+3, symStreamIndex-1-1) && symStream[symStreamIndex-1] == semicolon
    <==> ProcDecl(symStream, x, symStreamIndex-1);
    */

    /*@ loop invariant 
           currentCodeLineAndExtra && currentSymbol && symStream[symStreamIndex] == sym && 0 <= tx0 <= txmax && 0 <= \old(cx) <= cxmax+1 
           && index03 == \old(cx) && table[tx0].addr == index03 && index11 == \old(symStreamIndex) && tx0 == \old(tx) && tx >= tx0 
           && ConstDecl(symStream, index11, index21-1) && VarDecl(symStream, index21, index31-1) && index11 <= index21 <= index31 <= symStreamIndex
           && ProcDecSeq(symStream, index31, symStreamIndex-1) && code[index03].f == jmp && code[index03].l == 0 && code[index03].a == 0
           && ProcSeqCode(code, index03+1, cx-1) && symStreamIndex >= \old(symStreamIndex) >= 0 && (cx == \old(cx)+1 || cx >= \old(cx)+3)
           ;
    */
    while(sym==procsym){
        getsym();
        if(sym==ident){
            enter(proc);
            getsym();
        }else{
            error(4);
            /*@ ghost stop_here = true; */
            exit(2);                // 增加该语句是为了避免验证错误恢复功能。
        }
        if(sym==semicolon){
            getsym();
        }else{
            error(5);
            /*@ ghost stop_here = true; */
            exit(2);                // 增加该语句是为了避免验证错误恢复功能。
        }
        if(lev >= levmax){
            printf("%s\n", "nested levels are too shallow");
            //@ ghost nested_level_too_shallow = true;
            exit(1);
        }
        lev=lev+1; tx1=tx; dx1=dx;
        block(fsys|semicolon);
        if(lev <= 0){
            printf("%s\n", "nested levels are too shallow");
            //@ ghost nested_level_too_shallow = true;
            exit(1);
        }
        lev=lev-1; tx=tx1; dx=dx1;
        if(sym==semicolon){
            getsym();
            test(statbegsys|ident|procsym,fsys,6);
        }else{
            error(5);
            /*@ ghost stop_here = true; */
            exit(2);                // 增加该语句是为了避免验证错误恢复功能。
        }
    }
    test(statbegsys|ident,0,7);
    code[table[tx0].addr].a= cx;
    table[tx0].addr=cx;    // start addr of code
    cx0=cx; gen(Int,0,dx);
    statement(fsys|semicolon|endsym);
    gen(opr,0,0);    //return
    test(fsys,0,8);
    listcode(cx0);
}
